PROGRAM_NAME='Muxlab_AMX_Driver_Ex2'
(***********************************************************)
(*  FILE CREATED ON: 01/09/2017  AT: 11:19:06              *)
(***********************************************************)
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 01/10/2017  AT: 13:47:02        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
dvMuxLab = 0:3:0 //IP Port to connect to MuxLab controller
dvIPAD = 10001:1:0 //iPad Interface

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
long lMuxLabPort = 80 //MuxLab TCP Port number
char chMuxLabIP[] = '192.168.168.50' //IP Address of MuxLab controller
integer target = 1
integer ack = 1
integer  feed_back = 1
integer preset_ID = 1
integer feed_back = 1
char user[] = 'admin' 
char password[] = 'admin'
integer portIn = 1
integer portOut = 1
integer portInDisconnect = 0
char hex_data[] = 'AABBCCDDEEFF'
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE
volatile integer nMuxLabOnline //Variable to keep track if MuxLab is online with AMX
volatile strHttpHeader[300] //HTTP Header
ConnectionMode = false
VideoWallMode = false
topLeft = false
topRight = false
bottomLeft = false
bottomRight = false
choosenSourceTxPort = 0
choosenDisplayRxPort = 0

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)
DEFINE_FUNCTION fnSelectMuxLabPreset(integer nPreset) //Function used to pass preset number
{
  fnSendData("'{"p_targetId":1,"p_cmd":"select_preset","p_userName":"admin","p_password":"admin","p_data":[{"presetId":"',itoa(nPreset),'"}]}'")
}

DEFINE_FUNCTION connectionM (integer ntarget , char nuser[] , char npassword[] , integer nportIn , integer nportOut)
{
fnSendData("'{"p_targetId":',itoa(ntarget),',"p_cmd":"connection","p_userName":"',nuser,'","p_password":"', npassword, '","p_data":[{"portIn":"', itoa(nportIn),'","portOut":"', itoa(nportOut),'"}]}'")
	
}

define_function sendDataToRS232 (integer ntarget,  char nuser[], char npassword[], integer nport, char nhex_data[], integer nack, integer nfeed_back)
{

fnSendData("'{"p_targetId":',itoa(ntarget),',"p_cmd":"send_data_to_rs232","p_userName":"',nuser,'","p_password":"', npassword, '","p_data":[{"portIn":"', itoa(nport),'","hexdata":"', nhex_data,'", "ack":',itoa(nack),',"feedback":',itoa(nfeed_back),'"}]}'")

}

define_function sendDataToIr (integer ntarget, char nuser[], char npassword[], integer nport, char nhex_data[])
{
fnSendData("'{"p_targetId":',itoa(ntarget),',"p_cmd":"send_data_to_ir","p_userName":"',nuser,'","p_password":"', npassword, '","p_data":[{"portIn":"', itoa(nport),'","hexdata":"', nhex_data,'"}]}'")

}

define_function applyVideoWall (integer ntarget, char nuser[], char npassword[], integer nvwConfigId)
{

fnSendData("'{"p_targetId":',itoa(ntarget),',"p_cmd":"vwApplyConfig","p_userName":"',nuser,'","p_password":"', npassword, '","p_data":[{"vwConfigId":"', itoa(nvwConfigId),'"}]}'")

}

define_function applyVideoWallNewConfig (integer ntarget, char nuser[], char npassword[], integer nvwConfigId, integer newPortNumber)
{

fnSendData("'{"p_targetId":',itoa(ntarget),',"p_cmd":"vwApplyConfig","p_userName":"',nuser,'","p_password":"', npassword, '","p_data":[{"vwConfigId":"', itoa(nvwConfigId),'","portIn":"', itoa(newPortNumber),'"}]}'")

}




define_function preset (integer ntarget, char nuser[], char npassword[], integer npresetId)
{
fnSendData("'{"p_targetId":',itoa(ntarget),',"p_cmd":"select_preset","p_userName":"',nuser,'","p_password":"', npassword, '","p_data":[{"presetId":"', itoa(npresetId),'"}]}'")

}


define_function connectionAndVideoWall (integer choosenSourceTxPort,integer choosenDisplayRxPort )
{

 if(ConnectionMode == true)
  {
 send_string 0, " 'in the for function for connection' "
       connectionM (target, user, password, choosenSourceTxPort,  choosenDisplayRxPort  )

  }
  
  if(VideoWallMode == true)
  {
   send_string 0, " 'in the for function for video wall, tx= ' , choosenSourceTxPort "
 applyVideoWallNewConfig (target, user, password, preset_ID,choosenSourceTxPort)
  }
	
}


DEFINE_FUNCTION fnSendData(strJSONData[500])
{
  if(!nMuxLabOnline) //If MuxLab isn't online with AMX
  {
	ip_client_open(dvMuxLab.PORT,chMuxLabIP,lMuxLabPort,IP_TCP)
  }
  wait_until (nMuxLabOnline == TRUE)
  {
	send_string dvMuxLab,"strHttpHeader,itoa(length_array(strJSONData)),$0d,$0a,$0d,$0a,strJSONData"
	wait 4
	{
	  ip_client_close(dvMuxLab.PORT) //Used only to ensure that the socket is closed if MuxLab receives a non-valid command.
	}
  }
}
DEFINE_START
strHttpHeader = "'POST /mnc/secure_api.php HTTP/1.1',$0d,$0a,'HOST: ',chMuxLabIP,$0d,$0a, 'Connection:Keep-alive',$0d ,$0a,'content-type: application/json',$0d,$0a,'content-length: '"
set_pulse_time(15)
(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT
//button to set the mode and screen state
button_event[dvIPAD,54] //this is the button to choose the "connection" mode
{
  push:
  {

  //set connectionMode to true
  ConnectionMode = true
  VideoWallMode = false
  on[dvIPAD , 54]
  off[dvIPAD , 7]
  off[dvIPAD , 8]
  off[dvIPAD , 9]
  off[dvIPAD , 10]
		
  }
  release:
  {
  off[dvIPAD , 54]
  }
  
}

button_event[dvIPAD,2] //this is the button to choose the "video wall" mode
{
  push:
  {
  //set videoWallMode to true
  VideoWallMode = true  
  ConnectionMode = false

  on[dvIPAD , 2]
  on[dvIPAD , 7]
  on[dvIPAD , 8]
  on[dvIPAD , 9]
  on[dvIPAD , 10]
  

		
  }
  release:
  {
  off[dvIPAD , 2]
  }
  
}


button_event[dvIPAD,7] //this is the button to choose the top left screen
{
  push:
  {
  //set videoWallMode to true
  topLeft = true
  choosenDisplayRxPort = 1
  send_string 0, " 'choosenDisplayRxPort = '  , choosenDisplayRxPort "
  
  if (ConnectionMode == true)
  { 
 pulse[dvIPAD , 7]
 
  }
 
  }
 
}

button_event[dvIPAD,8] //this is the button to choose the top right screen
{
  push:
  {
  //set videoWallMode to true
  topRight = true
  choosenDisplayRxPort = 2
  send_string 0, " 'choosenDisplayRxPort = ' , choosenDisplayRxPort"
 	
 if (ConnectionMode == true)
  { 
  pulse[dvIPAD , 8]
  }

		
  }
 
  
}



button_event[dvIPAD,9] //this is the button to choose the bottom left screen
{
  push:
  {
  //set videoWallMode to true
  bottomLeft = true
  choosenDisplayRxPort = 3
   send_string 0, " 'choosenDisplayRxPort = '  , choosenDisplayRxPort"
		
if (ConnectionMode == true)
  { 
  pulse[dvIPAD , 9]
  }
  }
  
}

button_event[dvIPAD,10] //this is the button to choose the bottom right screen
{
  push:
  {
  //set videoWallMode to true
  bottomRight = true
  choosenDisplayRxPort = 4
  send_string 0, " 'choosenDisplayRxPort = '  , choosenDisplayRxPort"
		
  if (ConnectionMode == true)
  { 
 pulse[dvIPAD , 10]
  }
  }
  
}


//source devices 
button_event[dvIPAD,3] //this is the button to choose the media player on port 1 
{
  push:
  { 
  choosenSourceTxPort = 1
   send_string 0, " '/ VideoWallMode =' , VideoWallMode"
   
  on[dvIPAD , 3]
   //applyVideoWall (target, user, password, preset_ID)
  connectionAndVideoWall (choosenSourceTxPort,choosenDisplayRxPort )
  	
  }
  release:
  {
  off[dvIPAD , 3]
  }
  
}

button_event[dvIPAD,4] //this is the button to choose the apple tv on port 2
{
  push:
  {
  //check connection/videoWall setting
  choosenSourceTxPort = 2
  on[dvIPAD , 4]
  
 connectionAndVideoWall (choosenSourceTxPort,choosenDisplayRxPort )
		
  }	
  
  release:
  {
  off[dvIPAD , 4]
  }
  
}

button_event[dvIPAD,5] //this is the button to choose the laptop  on port 3
{
  push:
  {
  //check connection/videoWall setting 
  choosenSourceTxPort = 3 
  on[dvIPAD , 5]
  
  connectionAndVideoWall (choosenSourceTxPort,choosenDisplayRxPort )	
  		
  }
  release:
  {
  off[dvIPAD , 5]
  }
  
}

button_event[dvIPAD,6] //this is the button to choose the laptop  on port 4
{
  push:
  {
  //check connection/videoWall setting  
  choosenSourceTxPort = 4
  on[dvIPAD , 6]
  
 connectionAndVideoWall (choosenSourceTxPort,choosenDisplayRxPort )
		
  }
		
  release:
  {
  off[dvIPAD , 6]
  }
  
}


data_event[dvMuxLab]
{
  online:
  {
	nMuxLabOnline = TRUE
	send_string 0,"'MuxLab is online.'"
  }
  offline:
  {
	nMuxLabOnline = FALSE
	send_string 0,"'MuxLab is offline.'"
  }
  onerror:
  {
	nMuxLabOnline = FALSE
  }
  string:
  {
	send_string 0,"'RECEIVED DATA from MuxLab:>',data.text"
  }
}
(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)


